import { deviceFetch } from '../../api/fetch';

// miniprogram/pages/equipment/equipment.js
Page({
  /**
   * 页面的初始数据
   */
  data: {
    colors: ['#6895fe', '#fe6868', '#6ee18f', '#feae68'],
    areaDeviceAmount: [],
    statusAmount: [],
    totalAmount: [],
    total: 0,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    this.fetchList();
  },
  fetchList() {
    deviceFetch({
      url: '/device/report/mainPage',
    })
      .then(res => {
        console.log(res);
        const { areaDeviceAmount, statusAmount, totalAmount } = res.data;
        let total = totalAmount.reduce((count, item) => count + item.value, 0);
        this.setData!({
          areaDeviceAmount,
          statusAmount,
          totalAmount,
          total,
        });
      })
      .catch(err => {
        console.log(err);
      });
  },
  goReportPage(e) {
    const { index } = e.currentTarget.dataset;
    const item = this.data.areaDeviceAmount[index];
    wx.navigateTo({
      url: `/pages/equipmentReport/equipmentReport?areaId=${item.areaId}&areaName=${item.areaName}`,
      success: function(res) {
        // 通过eventChannel向被打开页面传送数据
        res.eventChannel.emit('acceptDataFromOpenerPage', { data: item });
      },
    });
  },
});
